



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring mvc 工作原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring mvc 工作原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-27 20:55:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>SpringMVC的工作原理图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/249993/201612/249993-20161212142542042-2117679195.jpg" /></p>
<h3>SpringMVC流程</h3>
<p>1、&nbsp; 用户发送请求至前端控制器DispatcherServlet。</p>
<p>2、&nbsp; DispatcherServlet收到请求调用HandlerMapping处理器映射器。</p>
<p>3、&nbsp; 处理器映射器找到具体的处理器(可以根据xml配置、注解进行查找)，生成处理器对象及处理器拦截器(如果有则生成)一并返回给DispatcherServlet。</p>
<p>4、&nbsp; DispatcherServlet调用HandlerAdapter处理器适配器。</p>
<p>5、&nbsp; HandlerAdapter经过适配调用具体的处理器(Controller，也叫后端控制器)。</p>
<p>6、&nbsp; Controller执行完成返回ModelAndView。</p>
<p>7、&nbsp; HandlerAdapter将controller执行结果ModelAndView返回给DispatcherServlet。</p>
<p>8、&nbsp; DispatcherServlet将ModelAndView传给ViewReslover视图解析器。</p>
<p>9、&nbsp; ViewReslover解析后返回具体View。</p>
<p>10、DispatcherServlet根据View进行渲染视图（即将模型数据填充至视图中）。</p>
<p>11、 DispatcherServlet响应用户。</p>
<h3>组件说明：</h3>
<p>以下组件通常使用框架提供实现：</p>
<p>DispatcherServlet：作为前端控制器，整个流程控制的中心，控制其它组件执行，统一调度，降低组件之间的耦合性，提高每个组件的扩展性。</p>
<p>HandlerMapping：通过扩展处理器映射器实现不同的映射方式，例如：配置文件方式，实现接口方式，注解方式等。</p>
<p>HandlAdapter：通过扩展处理器适配器，支持更多类型的处理器。</p>
<p>ViewResolver：通过扩展视图解析器，支持更多类型的视图解析，例如：jsp、freemarker、pdf、excel等。</p>
<p><strong>组件：</strong><br /><strong>1、前端控制器DispatcherServlet（不需要工程师开发）,由框架提供</strong><br />作用：接收请求，响应结果，相当于转发器，中央处理器。有了dispatcherServlet减少了其它组件之间的耦合度。<br />用户请求到达前端控制器，它就相当于mvc模式中的c，dispatcherServlet是整个流程控制的中心，由它调用其它组件处理用户的请求，dispatcherServlet的存在降低了组件之间的耦合性。</p>
<p><strong>2、处理器映射器HandlerMapping(不需要工程师开发),由框架提供</strong><br />作用：根据请求的url查找Handler<br />HandlerMapping负责根据用户请求找到Handler即处理器，springmvc提供了不同的映射器实现不同的映射方式，例如：配置文件方式，实现接口方式，注解方式等。</p>
<p><strong>3、处理器适配器HandlerAdapter</strong><br />作用：按照特定规则（HandlerAdapter要求的规则）去执行Handler<br />通过HandlerAdapter对处理器进行执行，这是适配器模式的应用，通过扩展适配器可以对更多类型的处理器进行执行。</p>
<p><strong>4、处理器Handler(需要工程师开发)</strong><br /><strong>注意：编写Handler时按照HandlerAdapter的要求去做，这样适配器才可以去正确执行Handler</strong><br />Handler 是继DispatcherServlet前端控制器的后端控制器，在DispatcherServlet的控制下Handler对具体的用户请求进行处理。<br />由于Handler涉及到具体的用户业务请求，所以一般情况需要工程师根据业务需求开发Handler。</p>
<p><strong>5、视图解析器View resolver(不需要工程师开发),由框架提供</strong><br />作用：进行视图解析，根据逻辑视图名解析成真正的视图（view）<br />View Resolver负责将处理结果生成View视图，View Resolver首先根据逻辑视图名解析成物理视图名即具体的页面地址，再生成View视图对象，最后对View进行渲染将处理结果通过页面展示给用户。 springmvc框架提供了很多的View视图类型，包括：jstlView、freemarkerView、pdfView等。<br />一般情况下需要通过页面标签或页面模版技术将模型数据通过页面展示给用户，需要由工程师根据业务需求开发具体的页面。</p>
<p><strong>6、视图View(需要工程师开发jsp...)</strong><br />View是一个接口，实现类支持不同的View类型（jsp、freemarker、pdf...）</p>
<p><strong>核心架构的具体流程步骤如下：</strong><br />1、首先用户发送请求&mdash;&mdash;&gt;DispatcherServlet，前端控制器收到请求后自己不进行处理，而是委托给其他的解析器进行处理，作为统一访问点，进行全局的流程控制；<br />2、DispatcherServlet&mdash;&mdash;&gt;HandlerMapping， HandlerMapping 将会把请求映射为HandlerExecutionChain 对象（包含一个Handler 处理器（页面控制器）对象、多个HandlerInterceptor 拦截器）对象，通过这种策略模式，很容易添加新的映射策略；<br />3、DispatcherServlet&mdash;&mdash;&gt;HandlerAdapter，HandlerAdapter 将会把处理器包装为适配器，从而支持多种类型的处理器，即适配器设计模式的应用，从而很容易支持很多类型的处理器；<br />4、HandlerAdapter&mdash;&mdash;&gt;处理器功能处理方法的调用，HandlerAdapter 将会根据适配的结果调用真正的处理器的功能处理方法，完成功能处理；并返回一个ModelAndView 对象（包含模型数据、逻辑视图名）；<br />5、ModelAndView的逻辑视图名&mdash;&mdash;&gt; ViewResolver， ViewResolver 将把逻辑视图名解析为具体的View，通过这种策略模式，很容易更换其他视图技术；<br />6、View&mdash;&mdash;&gt;渲染，View会根据传进来的Model模型数据进行渲染，此处的Model实际是一个Map数据结构，因此很容易支持其他视图技术；<br />7、返回控制权给DispatcherServlet，由DispatcherServlet返回响应给用户，到此一个流程结束。</p>
<p>下边两个组件通常情况下需要开发：</p>
<p>Handler：处理器，即后端控制器用controller表示。</p>
<p>View：视图，即展示给用户的界面，视图中通常需要标签语言展示模型数据。</p>
<p><strong>在将SpringMVC之前我们先来看一下什么是MVC模式</strong></p>
<p>MVC：MVC是一种设计模式</p>
<p>MVC的原理图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/249993/201702/249993-20170207135959401-404841652.png" /></p>
<p><strong>分析：</strong></p>
<p>M-Model 模型（完成业务逻辑：有javaBean构成，service+dao+entity）</p>
<p>V-View 视图（做界面的展示 &nbsp;jsp，html&hellip;&hellip;）</p>
<p>C-Controller 控制器（接收请求&mdash;&gt;调用模型&mdash;&gt;根据结果派发页面）</p>
<p><strong>springMVC是什么：</strong></p>
<p><strong>　　</strong>springMVC是一个MVC的开源框架，springMVC=struts2+spring，springMVC就相当于是Struts2加上sring的整合，但是这里有一个疑惑就是，springMVC和spring是什么样的关系呢？这个在百度百科上有一个很好的解释：意思是说，springMVC是spring的一个后续产品，其实就是spring在原有基础上，又提供了web应用的MVC模块，可以简单的把springMVC理解为是spring的一个模块（类似AOP，IOC这样的模块），网络上经常会说springMVC和spring无缝集成，其实springMVC就是spring的一个子模块，所以根本不需要同spring进行整合。</p>
<p><strong>SpringMVC的原理图：</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/249993/201702/249993-20170207140151791-1932120070.png" /></strong></p>
<p><strong>看到这个图大家可能会有很多的疑惑，现在我们来看一下这个图的步骤：（可以对比MVC的原理图进行理解）</strong></p>
<p>第一步:用户发起请求到前端控制器（DispatcherServlet）</p>
<p>第二步：前端控制器请求处理器映射器（HandlerMappering）去查找处理器（Handle）：通过xml配置或者注解进行查找</p>
<p>第三步：找到以后处理器映射器（HandlerMappering）像前端控制器返回执行链（HandlerExecutionChain）</p>
<p>第四步：前端控制器（DispatcherServlet）调用处理器适配器（HandlerAdapter）去执行处理器（Handler）</p>
<p>第五步：处理器适配器去执行Handler</p>
<p>第六步：Handler执行完给处理器适配器返回ModelAndView</p>
<p>第七步：处理器适配器向前端控制器返回ModelAndView</p>
<p>第八步：前端控制器请求视图解析器（ViewResolver）去进行视图解析</p>
<p>第九步：视图解析器像前端控制器返回View</p>
<p>第十步：前端控制器对视图进行渲染</p>
<p>第十一步：前端控制器向用户响应结果</p>
<p><strong>看到这些步骤我相信大家很感觉非常的乱，这是正常的，但是这里主要是要大家理解springMVC中的几个组件：</strong></p>
<p>前端控制器（DispatcherServlet）：接收请求，响应结果，相当于电脑的CPU。</p>
<p>处理器映射器（HandlerMapping）：根据URL去查找处理器</p>
<p>处理器（Handler）：（需要程序员去写代码处理逻辑的）</p>
<p>处理器适配器（HandlerAdapter）：会把处理器包装成适配器，这样就可以支持多种类型的处理器，类比笔记本的适配器（适配器模式的应用）</p>
<p>视图解析器（ViewResovler）：进行视图解析，多返回的字符串，进行处理，可以解析成对应的页面</p>
<p>http://www.cnblogs.com/wang-meng/p/5723601.html</p>
<p>http://www.cnblogs.com/xiaoxi/p/6164383.html</p>
<p>http://www.cnblogs.com/zbf1214/p/5265117.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2xmev9.html">【荐】使用eval&lpar;&rpar;、new Function&lpar;&rpar;将JSON字符串转换为JSON对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxo7kdq.html">jQuery 增加 删除 修改select option &period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961xwy8.html">BZOJ3461 &colon; Jry的时间表</a>
		</li>
						<li><a href="https://www.batexi.com/a/390w13nq.html">C&plus;&plus; TrieTree（字典树）容器的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1726e9.html">it warning&colon; LF will be replaced by CRLF解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg75x9.html">dom4j解析XML的CURD操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0k2xwq.html">浏览器文档播放Shockwave Flash 插件问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8menrr6q.html">Linux 多线程串口通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey64nk9.html">STL --&amp;gt&semi; set用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdojk79.html">MyBatis - 介绍、简单入门程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zy0gk9.html">IOS Dev 需要常看的网站&amp;lt&semi;转&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd2npz9.html">canvas-a10isPointPath&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j1rdeq.html">iot-dm异常日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwr0yd8.html">&lbrack;转&rsqb;HashMap&comma;LinkedHashMap&comma;TreeMap的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1mr709.html">【BZOJ】4380&colon; &lbrack;POI2015&rsqb;Myjnie</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvedv0z9.html">Android跑指定包Monkey脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emldoj9.html">（最短路  SPFA）Invitation Cards -- poj -- 1511</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkw4jd8.html">linux邮件客户端mutt日志文件，发不出邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pplg779.html">8个数据清洗Python代码，复制可用，最长11行 &vert; 资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odgdk5q.html">python进程锁</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnn5v5jq.html">Pandas DataFrame 数据选取和过滤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn0n5mq.html">idea开发工具安装说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn5nxkq.html">httpclient 使用代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k0mv3q.html">Kafka生产者APi</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko5nw7q.html">怎么让wordpress用sqlite3 搭建轻量级博客系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ennyk9.html">DevExpress v17&period;2&mdash;WPF篇（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o455x1q.html">mysql&vert;中主外键关系&lpar;转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl0rjk9.html">ios平台cocos2d-x播放音频、视频、音效的Demo（支持网络视频）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmp22w9.html">redis下载安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pnkvnq.html">DIY微型操作系统（2）&mdash;&mdash; 寄存器赋值</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
